/*
POS API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package posapi

import (
	"encoding/json"
)

// checks if the ContactData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactData{}

// ContactData struct for ContactData
type ContactData struct {
	ContactId string `json:"contact_id"`
	ChannelId string `json:"channel_id"`
	GatewayId string `json:"gateway_id"`
	ConversationId string `json:"conversation_id"`
}

// NewContactData instantiates a new ContactData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactData(contactId string, channelId string, gatewayId string, conversationId string) *ContactData {
	this := ContactData{}
	this.ContactId = contactId
	this.ChannelId = channelId
	this.GatewayId = gatewayId
	this.ConversationId = conversationId
	return &this
}

// NewContactDataWithDefaults instantiates a new ContactData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactDataWithDefaults() *ContactData {
	this := ContactData{}
	return &this
}

// GetContactId returns the ContactId field value
func (o *ContactData) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *ContactData) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *ContactData) SetContactId(v string) {
	o.ContactId = v
}

// GetChannelId returns the ChannelId field value
func (o *ContactData) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *ContactData) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *ContactData) SetChannelId(v string) {
	o.ChannelId = v
}

// GetGatewayId returns the GatewayId field value
func (o *ContactData) GetGatewayId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.GatewayId
}

// GetGatewayIdOk returns a tuple with the GatewayId field value
// and a boolean to check if the value has been set.
func (o *ContactData) GetGatewayIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.GatewayId, true
}

// SetGatewayId sets field value
func (o *ContactData) SetGatewayId(v string) {
	o.GatewayId = v
}

// GetConversationId returns the ConversationId field value
func (o *ContactData) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *ContactData) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *ContactData) SetConversationId(v string) {
	o.ConversationId = v
}

func (o ContactData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["contact_id"] = o.ContactId
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["gateway_id"] = o.GatewayId
	toSerialize["conversation_id"] = o.ConversationId
	return toSerialize, nil
}

type NullableContactData struct {
	value *ContactData
	isSet bool
}

func (v NullableContactData) Get() *ContactData {
	return v.value
}

func (v *NullableContactData) Set(val *ContactData) {
	v.value = val
	v.isSet = true
}

func (v NullableContactData) IsSet() bool {
	return v.isSet
}

func (v *NullableContactData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactData(val *ContactData) *NullableContactData {
	return &NullableContactData{value: val, isSet: true}
}

func (v NullableContactData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


